YssDarkPact = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "Sink-1.0")

local YDP_enable
local YDP_rank
local YDP_last_update = 0

function YssDarkPact:OnEnable()
	local _, Class = UnitClass("player")
	if Class == "WARLOCK" then
		local i = 1
		local _, _, offset, numSpells = GetSpellTabInfo(2);
		for s = offset + 1, offset + numSpells do
			local	spellName, spellRank = GetSpellName(s, BOOKTYPE_SPELL);
			if spellName == "Dark Pact" then
				YDP_enable = true
				if spellRank == 'Rank 1' then
					YDP_rank = 305
				elseif spellRank == 'Rank 2' then
					YDP_rank = 440
				elseif spellRank == 'Rank 3' then
					YDP_rank = 545
				elseif spellRank == 'Rank 4' then
					YDP_rank = 700
				end
			end
		end
		if YDP_enable then
			self:RegisterEvent("UNIT_MANA")
		end
	end
end

function YssDarkPact:UNIT_MANA(arg1)
	if arg1 == "pet" or arg1 == "player" then
		local YDP_stamp = GetTime()
		if YDP_stamp - YDP_last_update > 5 then
			if UnitManaMax("player") - UnitMana("player") > YDP_rank + (GetSpellBonusDamage(6) * .96) then
				if UnitMana("pet") >= YDP_rank + (GetSpellBonusDamage(6) * .96) then
					self:Pour("Dark Pact now!", 1, 0, 0, nil, 24, "OUTLINE", true)
					YDP_last_update = YDP_stamp
					return;
				end
			end
		end
	end
end
